
From: Heiko Carstens <heiko.carstens@de.ibm.com>

Use TIF bit to tell if a process is running in 31 bit mode instead of checking
the addressing mode bits of the PSW.

Signed-off-by: Heiko Carstens <heiko.carstens@de.ibm.com>
Signed-off-by: Martin Schwidefsky <schwidefsky@de.ibm.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 arch/s390/kernel/entry64.S |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

diff -puN arch/s390/kernel/entry64.S~s390-compat-system-calls arch/s390/kernel/entry64.S
--- devel/arch/s390/kernel/entry64.S~s390-compat-system-calls	2005-08-29 23:58:35.000000000 -0700
+++ devel-akpm/arch/s390/kernel/entry64.S	2005-08-29 23:58:35.000000000 -0700
@@ -214,8 +214,8 @@ sysc_nr_ok:
 sysc_do_restart:
 	larl    %r10,sys_call_table
 #ifdef CONFIG_S390_SUPPORT
-        tm      SP_PSW+3(%r15),0x01  # are we running in 31 bit mode ?
-        jo      sysc_noemu
+	tm	__TI_flags+5(%r9),(_TIF_31BIT>>16)  # running in 31 bit mode ?
+	jno	sysc_noemu
 	larl    %r10,sys_call_table_emu  # use 31 bit emulation system calls
 sysc_noemu:
 #endif
_
